Index: trunk/gui/scripts/analyzer.tcl
===================================================================
--- trunk/gui/scripts/analyzer.tcl	(revision 6716)
+++ trunk/gui/scripts/analyzer.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: analyzer - output area for Rappture
@@ -11,124 +10,36 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
-
-option add *Analyzer.width 3.5i widgetDefault
-option add *Analyzer.height 4i widgetDefault
-option add *Analyzer.simControl "auto" widgetDefault
-option add *Analyzer.simControlBackground "" widgetDefault
-option add *Analyzer.simControlOutline gray widgetDefault
-option add *Analyzer.simControlActiveBackground #ffffcc widgetDefault
-option add *Analyzer.simControlActiveOutline black widgetDefault
-option add *Analyzer.notebookpage "about" widgetDefault
-
-option add *Analyzer.font \
-    -*-helvetica-medium-r-normal-*-12-* widgetDefault
-option add *Analyzer.codeFont \
-    -*-courier-medium-r-normal-*-12-* widgetDefault
+package require BLT
+
 option add *Analyzer.textFont \
-    -*-helvetica-medium-r-normal-*-12-* widgetDefault
-option add *Analyzer.boldTextFont \
-    -*-helvetica-bold-r-normal-*-12-* widgetDefault
+    -*-helvetica-medium-r-normal-*-*-120-* widgetDefault
 
 itcl::class Rappture::Analyzer {
     inherit itk::Widget
 
-    itk_option define -codefont codeFont Font ""
-    itk_option define -textfont textFont Font ""
-    itk_option define -boldtextfont boldTextFont Font ""
-    itk_option define -simcontrol simControl SimControl ""
-    itk_option define -simcontroloutline simControlOutline Background ""
-    itk_option define -simcontrolbackground simControlBackground Background ""
-    itk_option define -simcontrolactiveoutline simControlActiveOutline Background ""
-    itk_option define -simcontrolactivebackground simControlActiveBackground Background ""
+    itk_option define -tool tool Tool ""
+    itk_option define -device device Device ""
+    itk_option define -analysis analysis Analysis ""
     itk_option define -holdwindow holdWindow HoldWindow ""
-    itk_option define -notebookpage notebookPage NotebookPage ""
-
-    constructor {tool args} {
-        # defined below
-    }
-    destructor {
-        # defined below
-    }
-
-    public method simulate {args}
-    public method reset {{when -eventually}}
-    public method load {xmlobj}
-    public method reload { fileName }
-    public method clear {{xmlobj "all"}}
-    public method download {option args}
-    public method buildMenu { w url appName }
-
-    protected method _plot {args}
-    protected method _reorder {comps}
-    protected method _autoLabel {xmlobj path title cntVar}
+
+    constructor {args} { # defined below }
+    destructor { # defined below }
+
+    public method simulate {}
+    public method reset {}
+    public method load {file}
+
     protected method _fixResult {}
-    protected method _fixResultSet {args}
-    protected method _fixSize {}
-    protected method _fixSimControl {}
-    protected method _fixNotebook {}
-    protected method _simState {state args}
-    protected method _simOutput {message}
-    protected method _resultTooltip {}
-    protected method _isPdbTrajectory {data}
-    protected method _isLammpsTrajectory {data}
-    protected method _pdbToSequence {xmlobj path id child data}
-    protected method _lammpsToSequence {xmlobj path id child data}
-    protected method _trajToSequence {xmlobj {path ""}}
-    protected method _pop_uq_dialog {win}
-    protected method _setWaitVariable {state}
-    protected method _adjust_level {win}
-
-    private variable _done 0
-    private variable _tree ""
-    private variable _saved 
-    private variable _name "" 
-    private variable _revision 0;       # Tool revision
-    private variable _tool ""          ;# belongs to this tool
-    private variable _appName ""       ;# Name of application
+
+    private variable _run ""           ;# results from last run
     private variable _control "manual" ;# start mode
-    private variable _resultset ""     ;# ResultSet object with all results
-    private variable _pages 0          ;# number of pages for result sets
-    private variable _label2page       ;# maps output label => result set
-    private variable _label2desc       ;# maps output label => description
-    private variable _label2item       ;# maps output label => output.xxx item
-    private variable _lastlabel ""     ;# label of last example loaded
-    private variable _plotlist ""      ;# items currently being plotted
-    private variable _lastPlot
-    private variable _uq_active 0      ;# a UQ variables has been used
-    private variable _wait_uq 0
+    private variable _widgets          ;# maps analyze section => widget
+
     private common job                 ;# array var used for blt::bgexec jobs
-
-    private method BuildQuestionDialog { popup }
-    private method BuildSimulationTable { w }
-    private method Cancel {}
-    private method CheckSimsetDetails {}
-    private method CleanName { name }
-    private method CreateSharedPath { path } 
-    private method EditSimset {}
-    private method ExportFile { src msgFile }
-    private method ExportURL { appName installdir } 
-    private method FindSimsetsForApp { appName }
-    private method GetSimset { name }
-    private method InstallSharedFile { installdir file } 
-    private method LoadSimulations { runfiles }
-    private method Ok {}
-    private method OverwriteSaveFile {}
-    private method PostMenu { menu }
-    private method ReadSimsetFile { fileName }
-    private method Save {}
-    private method SaveSimulations {}
-    private method SelectSimsetForDeletion {}
-    private method SelectSimsetForLoading {}
-    private method SelectSimsetNameAndSave {}
-    private method SelectSimsetToShare {}
-    private method WriteSimsetFile { appName fileName share }
-}
-
+}
+                                                                                
 itk::usual Analyzer {
     keep -background -cursor foreground -font
@@ -138,126 +49,9 @@
 # CONSTRUCTOR
 # ----------------------------------------------------------------------
-itcl::body Rappture::Analyzer::constructor {tool args} {
-    set _tool $tool
-    set _tree [blt::tree create]
-
-    # use this to store all simulation results
-    set _resultset [Rappture::ResultSet ::\#auto]
-    $_resultset notify add $this [itcl::code $this _fixResultSet]
-
-    # widget settings...
-    itk_option add hull.width hull.height
-    pack propagate $itk_component(hull) no
-
-    frame $itk_interior.simol -borderwidth 1 -relief flat
-    pack $itk_interior.simol -fill x
-
-    itk_component add simbg {
-        frame $itk_interior.simol.simbg -borderwidth 0
-    } {
-        usual
-        rename -background -simcontrolcolor simControlColor Color
-    }
-    pack $itk_component(simbg) -expand yes -fill both
-
-    set simtxt [string trim [$tool xml get tool.action.label]]
-    if {"" == $simtxt} {
-        set simtxt "Simulate"
-    }
-    itk_component add simulate {
-        button $itk_component(simbg).simulate -text $simtxt \
-            -command [itcl::code $this simulate]
-    } {
-        usual
-        rename -highlightbackground -simcontrolcolor simControlColor Color
-    }
-    pack $itk_component(simulate) -side left -padx 4 -pady 4
-
-    # BE CAREFUL: Shift focus when we click on "Simulate".
-    #   This shifts focus away from input widgets and causes them to
-    #   finalize and log any pending changes.  A better way would be
-    #   to have the "sync" operation finalize/sync, but this works
-    #   for now.
-    bind $itk_component(simulate) <ButtonPress> {focus %W}
-
-    # if there's a hub url, then add "About" and "Questions" links
-    global rapptureInfo
-    if { $rapptureInfo(appName) == "" } {
-        set _appName [$_tool xml get "tool.id"]
-    } else {
-        set _appName $rapptureInfo(appName)
-    }
-    set num [$_tool xml get "tool.version.application.revision"]
-    if { $num == "" } {
-        set num 0
-    }
-    set _revision $num
-    set url [Rappture::Tool::resources -huburl]
-
-    itk_component add hubcntls {
-        frame $itk_component(simbg).hubcntls
-    } {
-        usual
-        rename -background -simcontrolcolor simControlColor Color
-    }
-    pack $itk_component(hubcntls) -side right -padx 4
-    
-    itk_component add help {
-        menubutton $itk_component(hubcntls).help \
-            -image [Rappture::icon hamburger_menu] \
-            -highlightthickness 0 \
-            -menu $itk_component(hubcntls).help.menu
-    } {
-        usual
-        ignore -highlightthickness
-        rename -background -simcontrolcolor simControlColor Color
-    }
-    pack $itk_component(help) -side left
-    buildMenu $itk_component(help).menu $url $_appName
-    
-    itk_component add simstatus {
-        text $itk_component(simbg).simstatus -borderwidth 0 \
-            -highlightthickness 0 -height 1 -width 1 -wrap none \
-            -state disabled
-    } {
-        usual
-        ignore -highlightthickness
-        rename -background -simcontrolcolor simControlColor Color
-        rename -font -textfont textFont Font
-    }
-    pack $itk_component(simstatus) -side left -expand yes -fill x
-
-    $itk_component(simstatus) tag configure popup \
-        -underline 1 -foreground blue
-
-    $itk_component(simstatus) tag bind popup \
-        <Enter> {%W configure -cursor center_ptr}
-    $itk_component(simstatus) tag bind popup \
-        <Leave> {%W configure -cursor ""}
-    $itk_component(simstatus) tag bind popup \
-        <ButtonPress> {after idle {Rappture::Tooltip::tooltip show %W}}
-
-
+itcl::body Rappture::Analyzer::constructor {args} {
     itk_component add notebook {
         Rappture::Notebook $itk_interior.nb
     }
     pack $itk_interior.nb -expand yes -fill both
-
-    # ------------------------------------------------------------------
-    # ABOUT PAGE
-    # ------------------------------------------------------------------
-    set w [$itk_component(notebook) insert end about]
-
-    Rappture::Scroller $w.info -xscrollmode off -yscrollmode auto
-    pack $w.info -expand yes -fill both -padx 4 -pady 20
-    itk_component add toolinfo {
-        text $w.info.text -width 1 -height 1 -wrap word \
-            -borderwidth 0 -highlightthickness 0
-    } {
-        usual
-        ignore -borderwidth -relief
-        rename -font -textfont textFont Font
-    }
-    $w.info contents $w.info.text
 
     # ------------------------------------------------------------------
@@ -266,18 +60,24 @@
     set w [$itk_component(notebook) insert end simulate]
     frame $w.cntls
-    pack $w.cntls -side bottom -fill x -pady 12
-    frame $w.cntls.sep -background black -height 1
-    pack $w.cntls.sep -side top -fill x
-
-    itk_component add abort {
-        button $w.cntls.abort -text "Abort" \
-            -command [itcl::code $_tool abort]
-    }
-    pack $itk_component(abort) -side left -expand yes -padx 4 -pady 4
-
-    Rappture::Scroller $w.info -xscrollmode auto -yscrollmode auto
-    pack $w.info -expand yes -fill both -padx 4 -pady 4
-    itk_component add runinfo {
-        text $w.info.text -width 1 -height 1 -wrap none \
+    pack $w.cntls -side top -fill x -padx {20 2}
+
+    itk_component add simulate {
+        button $w.cntls.sim -text "Simulate" \
+            -command [itcl::code $this simulate]
+    }
+    pack $itk_component(simulate) -side left
+
+    itk_component add status {
+        label $w.cntls.info -width 1 -text "" -anchor w
+    } {
+        usual
+        rename -font -textfont textFont Font
+    }
+    pack $itk_component(status) -side left -expand yes -fill both
+
+    Rappture::Scroller $w.info -xscrollmode off -yscrollmode auto
+    pack $w.info -expand yes -fill both -padx {20 2} -pady {20 2}
+    itk_component add info {
+        text $w.info.text -width 1 -height 1 -wrap word \
             -borderwidth 0 -highlightthickness 0 \
             -state disabled
@@ -285,11 +85,7 @@
         usual
         ignore -borderwidth -relief
-        rename -font -codefont codeFont Font
+        rename -font -textfont textFont Font
     }
     $w.info contents $w.info.text
-
-    itk_component add progress {
-        Rappture::Progress $w.progress
-    }
 
     # ------------------------------------------------------------------
@@ -298,103 +94,19 @@
     set w [$itk_component(notebook) insert end analyze]
 
-    frame $w.top
-    pack $w.top -side top -fill x -pady 8
-    label $w.top.l -text "Result:" -font $itk_option(-font)
-    pack $w.top.l -side left
-
-    itk_component add viewselector {
-        Rappture::Combobox $w.top.sel -width 10 -editable no
+    itk_component add resultselector {
+        Rappture::Combobox $w.sel -width 30 -editable no
     } {
         usual
         rename -font -textfont textFont Font
     }
-    pack $itk_component(viewselector) -side left -expand yes -fill x
-    bind $itk_component(viewselector) <<Value>> [itcl::code $this _fixResult]
-    bind $itk_component(viewselector) <Enter> \
-        [itcl::code $this download coming]
-
-    Rappture::Tooltip::for $itk_component(viewselector) \
-        "@[itcl::code $this _resultTooltip]"
-
-    $itk_component(viewselector) choices insert end \
-        --- "---"
-
-    itk_component add download {
-        button $w.top.dl -image [Rappture::icon download] -anchor e \
-            -borderwidth 1 -relief flat -overrelief raised \
-            -command [itcl::code $this download start $w.top.dl]
-    }
-    pack $itk_component(download) -side right -padx {4 0}
-    bind $itk_component(download) <Enter> \
-        [itcl::code $this download coming]
-
-    $itk_component(viewselector) choices insert end \
-        @download [Rappture::filexfer::label download]
-
-    if {[Rappture::filexfer::enabled]} {
-        Rappture::Tooltip::for $itk_component(download) "Downloads the current result to a new web browser window on your desktop.  From there, you can easily print or save results.
-
-NOTE:  Your web browser must allow pop-ups from this site.  If your output does not appear, look for a 'pop-up blocked' message and enable pop-ups."
-    } else {
-        Rappture::Tooltip::for $itk_component(download) "Saves the current result to a file on your desktop."
-    }
+    pack $itk_component(resultselector) -side top -fill x -padx {20 2}
+    bind $itk_component(resultselector) <<Value>> [itcl::code $this _fixResult]
 
     itk_component add results {
-        Rappture::Panes $w.pane \
-            -sashwidth 2 -sashrelief solid -sashpadding {2 0}
-    } {
-        usual
-        ignore -sashwidth -sashrelief -sashpadding
-    }
-    pack $itk_component(results) -expand yes -fill both
-    set f [$itk_component(results) pane 0]
-
-    itk_component add resultpages {
-        Rappture::Notebook $f.nb
-    }
-    pack $itk_component(resultpages) -expand yes -fill both
-    set f [$itk_component(results) insert end -fraction 0.1]
-    itk_component add resultselector {
-        Rappture::ResultSelector $f.rsel -resultset $_resultset \
-            -settingscommand [itcl::code $this _plot]
-    }
-    pack $itk_component(resultselector) -expand yes -fill both
-    bind $itk_component(resultselector) <<Layout>> [itcl::code $this _fixSize]
-    bind $itk_component(results) <Configure> [itcl::code $this _fixSize]
+        Rappture::Notebook $w.nb
+    }
+    pack $itk_component(results) -expand yes -fill both -pady 4
 
     eval itk_initialize $args
-
-    $itk_component(runinfo) tag configure ERROR -foreground red
-    $itk_component(runinfo) tag configure text -font $itk_option(-textfont)
-
-    #
-    # Load up tool info on the first page.
-    #
-    $itk_component(toolinfo) tag configure title \
-        -font $itk_option(-boldtextfont)
-
-    set mesg [string trim [$tool xml get tool.title]]
-    if {"" != $mesg} {
-        $itk_component(toolinfo) insert end $mesg title
-        $itk_component(toolinfo) insert end "\n\n"
-    }
-
-    set mesg [string trim [$tool xml get tool.about]]
-    if {"" != $mesg} {
-        $itk_component(toolinfo) insert end $mesg
-    }
-    $itk_component(toolinfo) configure -state disabled
-    $itk_component(notebook) current about
-
-    # tool can run on "manual" (default) or "auto"
-    set cntl [string trim [$tool xml get tool.control]]
-    if {"" == $cntl} {
-        set cntl [string trim [$tool xml get tool.control.type]]
-    }
-    if {"" != $cntl} {
-        set _control $cntl
-    }
-
-    # reset everything to a clean state
     reset
 }
@@ -404,123 +116,89 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Analyzer::destructor {} {
-    after cancel [itcl::code $this simulate]
-    $_resultset notify remove $this
-    itcl::delete object $_resultset
-}
-
-# ----------------------------------------------------------------------
-# USAGE: simulate ?-ifneeded?
-# USAGE: simulate ?<path1> <value1> <path2> <value2> ...?
-#
-# Kicks off the simulator by executing the tool.command associated
-# with the tool.  If any arguments are specified, they are used to
-# set parameters for the simulation.  While the simulation is running,
-# it shows status.  When the simulation is finished, it switches
-# automatically to "analyze" mode and shows the results.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Analyzer::simulate {args} {
-
-    set uq [$_tool get_uq -uq_type smolyak -uq_args 2]
-
-    # pop up UQ window
-    if {[$uq num_runs] > 1} {
-        set _uq_active 1
-        set status [$uq run_dialog $itk_component(simulate)]
+    if {$_run != ""} {
+        itcl::delete object $_run
+    }
+}
+
+# ----------------------------------------------------------------------
+# USAGE: simulate
+#
+# If the simulation page is showing, this kicks off the simulator
+# by executing the executable.command associated with the -tool.  While
+# the simulation is running, it shows status.  When the simulation is
+# finished, it switches automatically to "analyze" mode and shows
+# the results.
+# ----------------------------------------------------------------------
+itcl::body Rappture::Analyzer::simulate {} {
+    if {[$itk_component(notebook) current] == "simulate"} {
+        $itk_component(status) configure -text "Running simulation..."
+        $itk_component(simulate) configure -text "Abort" \
+            -command {set ::Rappture::Analyzer::job(control) abort}
+
+        set job(control) ""
+
+        # if the hold window is set, then put up a busy cursor
+        if {$itk_option(-holdwindow) != ""} {
+            blt::busy hold $itk_option(-holdwindow)
+            raise $itk_component(hull)
+            update
+        }
+
+        # write out the driver.xml file for the tool
+        set status [catch {
+            set fid [open driver.xml w]
+            puts $fid "<?xml version=\"1.0\"?>"
+            set xml [$itk_option(-tool) xml]
+            set xml2 [$itk_option(-device) xml]
+            regsub -all {&} $xml2 {\\\&} xml2
+            regsub {</tool>} $xml "$xml2</tool>" xml
+            puts $fid $xml
+            close $fid
+        } result]
+
+        # execute the tool using the path from the tool description
         if {$status == 0} {
-            # cancelled
-            return
-        }
-        lappend args -uq_type [$uq type]
-        lappend args -uq_args [$uq args]
-        # Need to put these UQ values into the driver file
-        # so the call to resultset::contains will be correct.
-        set _xml [$_tool xml object]
-        $_xml put uq.type.current [$uq type]
-        $_xml put uq.args.current [$uq args]
-        $_xml put uq.args.about.label "level"
-        $_xml put uq.args.about.description "Polynomial Degree of Smolyak GPC method."
-    }
-    #puts "simulate args=$args"
-
-    if {[lindex $args 0] == "-ifneeded"} {
-        # check to see if simulation is really needed
-        $_tool sync
-        if {[$_resultset contains [$_tool xml object]] &&
-            ![string equal $_control "manual-resim"]} {
-            # not needed -- show results and return
+            set cmd [$itk_option(-tool) get executable.command]
+
+            set status [catch {eval blt::bgexec \
+                ::Rappture::Analyzer::job(control) \
+                -output ::Rappture::Analyzer::job(output) \
+                -error ::Rappture::Analyzer::job(error) $cmd} result]
+        }
+
+        # read back the results from run.xml
+        if {$status == 0} {
+            set status [catch {load run.xml} result]
+        }
+
+        # back to normal
+        if {$itk_option(-holdwindow) != ""} {
+            blt::busy release $itk_option(-holdwindow)
+        }
+        $itk_component(status) configure -text ""
+        $itk_component(simulate) configure -text "Simulate" \
+            -command [itcl::code $this simulate]
+
+        # if anything went wrong, tell the user; otherwise, analyze
+        if {[regexp {^KILLED} $job(control)]} {
+            # job aborted -- do nothing
+        } elseif {$status != 0} {
+            $itk_component(info) configure -state normal
+            $itk_component(info) delete 1.0 end
+            $itk_component(info) insert end "Problem launching job:\n"
+            if {[string length $job(error)] > 0} {
+                $itk_component(info) insert end $job(error)
+            } else {
+                $itk_component(info) insert end $result
+            }
+            $itk_component(info) configure -state disabled
+        } else {
             $itk_component(notebook) current analyze
-            return
-        }
-        set args [lreplace $args 0 0]
-    }
-
-    # simulation is needed -- go to simulation page
-    $itk_component(notebook) current simulate
-
-    # no progress messages yet
-    pack forget $itk_component(progress)
-    lappend args -output [itcl::code $this _simOutput]
-
-    _simState off
-    $itk_component(runinfo) configure -state normal
-    $itk_component(runinfo) delete 1.0 end
-    $itk_component(runinfo) insert end "Running simulation...\n\n" text
-    $itk_component(runinfo) configure -state disabled
-
-    # if the hold window is set, then put up a busy cursor
-    if {$itk_option(-holdwindow) != ""} {
-        blt::busy hold $itk_option(-holdwindow)
-        raise $itk_component(hull)
-    }
-
-    # execute the job
-    #puts "$_tool run $args"
-
-    foreach {status result} [eval $_tool run $args] break
-
-    # if job was aborted, then allow simulation again
-    if {$result == "ABORT"} {
-        _simState on "Aborted"
-    }
-
-    # load results from run.xml into analyzer
-    if {$status == 0 && $result != "ABORT"} {
-        set status [catch {load $result} result]
-    }
-
-    # back to normal
-    if {$itk_option(-holdwindow) != ""} {
-        blt::busy release $itk_option(-holdwindow)
-    }
-    $itk_component(abort) configure -state disabled
-
-    if {$status != 0} {
-        $itk_component(runinfo) configure -state normal
-        # Don't erase program error messages.
-        # $itk_component(runinfo) delete 1.0 end
-        $itk_component(runinfo) insert end "\n\nProblem launching job:\n\n" text
-        _simOutput $result
-        $itk_component(runinfo) configure -state disabled
-        $itk_component(runinfo) see 1.0
-
-        # Try to create a support ticket for this error.
-        # It may be a real problem.
-        if {[Rappture::bugreport::shouldReport for jobs]} {
-            set ::errorInfo "\n\n== RAPPTURE INPUT ==\n[$_tool xml xml]"
-            Rappture::bugreport::register "Problem launching job:\n$result"
-            Rappture::bugreport::attachment [$_tool xml xml]
-            Rappture::bugreport::send
-        }
-    } else {
-        $itk_component(notebook) current analyze
-    }
-
-    # do this last -- after _simOutput above
-    pack forget $itk_component(progress)
-}
-
-
-# ----------------------------------------------------------------------
-# USAGE: reset ?-eventually|-now?
+        }
+    }
+}
+
+# ----------------------------------------------------------------------
+# USAGE: reset
 #
 # Used to reset the analyzer whenever the input to a simulation has
